

import {Component} from '@angular/core';
import {IonicPage, NavController, NavParams, AlertController, ModalController, ToastController, App} from 'ionic-angular';
import {AuthService} from "../../providers/auth-service";
import {Common} from "../../providers/common";
import {PosPenjualan} from '../pos-penjualan/pos-penjualan';

import {PrintProvider} from '../../providers/print/print';
import {PrinterListModalPage} from '../printer-list-modal/printer-list-modal';

@IonicPage()
@Component({
    selector: 'page-bayar-tunai',
    templateUrl: 'bayar-tunai.html',
})
export class BayarTunaiPage {
    selectedPrinter: any = [];
    mask = [/\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
    public recartData: any;
    public cartData: any;
    public resposeData: any;
    public dataSet: any;
    /*mengambil data sebelumnya */
    total_item: number;
    cart_id: string;
    username: string;
    Deskripsi: string;
    nama_pelanggan: string;
    catatan: string;
    diskon: string;
    grand_total: number;
    jumlah_diskon_rupiah: number;
    jumlah_diskon: number;
    promo: string;
    pajak: number;
    total: number;
    quantity: number;
    price: number;
    userCart = {
        cart_id: "",
        id_pelanggan: "",
        nama_pelanggan: "",
        username: "",
        ItemID: "",
        token: "",
        cart_item_id: "",
        catatan: "",
        diskon: "",
        diskon_persen: 0,
        jumlah_diskon: 0,
        promo: "",
        ppn: 10,
        ppn_rupiah: 0,
        total_item: "",
        payment: "",
        provider: "",
        payment_number: 0,
        payment_atachment: 0,
        dibayar: 0,
        kembalian: 0,
        total: 0,
    }

    constructor(public navCtrl: NavController,
        public authService: AuthService,
        public alertCtrl: AlertController,
        public common: Common,
        public navParams: NavParams,
        private toastCtrl: ToastController,
        private modalCtrl: ModalController,
        private printProvider: PrintProvider,
        private app: App) {
        this.navParams = navParams;
        this.userCart = this.navParams.data;
        this.userCart.dibayar = 0;
        this.userCart.kembalian = 0;
        this.getCart();
        this.getSummary();
    }

    getSummary() {
        this.authService.postData(this.userCart, "getSummary").then(
            result => {
                this.recartData = result;
                if (this.recartData.summaryData) {
                    this.cartData = this.recartData.summaryData;
                    this.userCart.cart_id = this.cartData[0].cart_id;
                    this.userCart.total_item = this.cartData[0].total_item;
                    this.userCart.total = this.cartData[0].total;
                    this.userCart.username = this.userCart.username;
                    this.total_item = this.cartData[0].total_item;
                    this.total = this.cartData[0].total;
                    this.hitung_diskon();
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    getCart() {
        this.authService.postData(this.userCart, "getCart").then(
            result => {
                this.recartData = result;
                if (this.recartData.cartData) {
                    this.dataSet = this.recartData.cartData;
                    this.userCart.cart_id = this.dataSet[0].cart_id;
                    this.userCart.id_pelanggan = this.dataSet[0].id_pelanggan;
                    this.nama_pelanggan = this.dataSet[0].nama_depan + " " + this.dataSet[0].nama_belakang;
                    this.catatan = this.userCart.catatan;
                    this.userCart.ppn = this.userCart.ppn;
                    if (this.userCart.promo) {
                        this.promo = this.userCart.promo;
                    } else {
                        this.promo = "-"
                    }
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    hitung() {
        this.userCart.kembalian = this.userCart.dibayar - this.total;
    }

    simpan_email() {
        if (this.userCart.payment_atachment < 0) {
            this.presentToast("Jumlah pembayaran yang anda masukan tidak mencukupi.");
        } else {
            console.log(this.cartData);
            this.insertPenjualan();
        }
    }



    insertPenjualan() {
        this.userCart.payment = "CASH";
        if (this.userCart.cart_id) {
            this.authService.postData(this.userCart, "insertPenjualan").then(
                result => {
                    this.resposeData = result;
                    if (this.resposeData.cartData) {
                        this.app.getRootNav().setRoot(PosPenjualan);
                    }
                },
                err => {
                    this.presentToast("Gagal terhubung ke server.");
                }
            );
        } else {
            this.common.closeLoading();
            this.presentToast("Gagal mengambil produk.");
        }
    }

    hitung_diskon() {
        if (this.userCart.diskon === 'IDR') {
            this.jumlah_diskon_rupiah = (this.userCart.jumlah_diskon / this.total) * 100;
            this.diskon = parseFloat("" + this.jumlah_diskon_rupiah.toFixed(2)) + "%";
            this.jumlah_diskon = this.total * this.jumlah_diskon_rupiah / 100;
            this.jumlah_diskon = parseFloat("" + this.jumlah_diskon.toFixed(0));
            this.userCart.ppn_rupiah = this.total * 10 / 100;
            this.pajak = this.userCart.ppn_rupiah;
            this.grand_total = (this.total - this.jumlah_diskon) + this.userCart.ppn_rupiah;
            this.userCart.diskon_persen = this.jumlah_diskon_rupiah;
            this.userCart.dibayar = this.grand_total;
        } else {
            this.userCart.diskon === 'Persen'
            this.diskon = this.userCart.jumlah_diskon + "%";
            this.jumlah_diskon = this.total * this.userCart.jumlah_diskon / 100;
            this.userCart.ppn_rupiah = this.total * 10 / 100;
            this.pajak = this.userCart.ppn_rupiah;
            this.grand_total = (this.total - this.jumlah_diskon) + this.userCart.ppn_rupiah;
            this.userCart.diskon_persen = this.userCart.jumlah_diskon;
            this.userCart.jumlah_diskon = this.jumlah_diskon;
            this.userCart.dibayar = this.grand_total;
        }
    }
    presentToast(msg) {
        let toast = this.toastCtrl.create({
            message: msg,
            duration: 3000
        });
        toast.present();
    }

    //printer
    listBTDevice() {
        this.printProvider.searchBt().then(datalist => {
            //IF DEFAULT PRINTER

            //1. Open printer select modal
            let abc = this.modalCtrl.create(PrinterListModalPage, {data: datalist});

            //2. Printer selected, save into this.selectedPrinter
            abc.onDidDismiss(data => {
                this.selectedPrinter = data;

                let xyz = this.alertCtrl.create({
                    title: data.name + " selected",
                    buttons: ['Dismiss']
                });
                xyz.present();

            });

            //0. Present Modal
            abc.present();

        }, err => {
            console.log("ERROR", err);
            let mno = this.alertCtrl.create({
                title: "ERROR " + err,
                buttons: ['Dismiss']
            });
            mno.present();
        })

    }

    testConnectPrinter() {
        var id = this.selectedPrinter.id;
        if (id == null || id == "" || id == undefined) {
            id = 'RPP210'; //MENENTUKAN SENDIRI DEVICE YG ADA

            this.printProvider.connectBT(id).subscribe(data => {
                console.log("CONNECT SUCCESSFUL", data);

                let mno = this.alertCtrl.create({
                    title: "Connect successful",
                    buttons: ['Dismiss']
                });
                mno.present();

            }, err => {
                console.log("Not able to connect", err);
                let mno = this.alertCtrl.create({
                    title: "ERROR " + err,
                    buttons: ['Dismiss']
                });
                mno.present();
            });
        }
    }

    testPrint() {
        this.getCart();
        var id = this.selectedPrinter.id;
        if (id == null || id == "" || id == undefined) {
            //id = 'RPP210'; //MENENTUKAN SENDIRI DEVICE YG ADA
        } else{
            var hari = ['Minggu', 'Senin', 'Selasa', 'Rabu', 'Kamis', 'Jum&#39;at', 'Sabtu'];
            var bulan = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'];
            var tanggal = new Date().getDate();
            var _hari = new Date().getDay();
            var _bulan = new Date().getMonth();
            var _tahun = new Date().getFullYear();
            var ha = hari[_hari];
            var bu = bulan[_bulan];
            var ta = (_tahun < 1000) ? _tahun + 2017 : _tahun;
            var jam = new Date().getHours();
            var menit = new Date().getMinutes();
            var detik = new Date().getSeconds();

            var receipt = '';
            receipt += '\x1d\x57\x80\x31';
            receipt += '\x1b\x40'; // Clear data in buffer and reset modes
            receipt += '\x1b\x61\x01';
            receipt += '\x1b\x21\x20';
            receipt += 'Kara Island';
            receipt += '\n';
            receipt += '\x1b\x21\x00';
            receipt += 'Gandaria City, Lantai 2';
            receipt += '\n';
            receipt += 'Jl. Sultan Iskandar Muda \n Gandaria, Jakarta';
            receipt += '\n';
            receipt += '0812 19999 6767\n';
            receipt += '--------------------------------\n';
            receipt += '\x1b\x61\x00';
            receipt += ha + ', '+ tanggal +'/' + bu + '/' + ta + ' ' + jam + ':'+ menit + ':' + detik + ' WIB \n';
            receipt += '\x1b\x1d\x61\x02';
            receipt += 'Kasir:'+this.userCart.username + '\n';
            receipt += '--------------------------------\n';
            for (var i = 0; i < this.total_item; i++) {
                receipt += '\x1b\x61\x00'; // Left justification
                receipt += 'X';
                receipt += this.dataSet[i].quantity + '  ';
                receipt += this.dataSet[i].ItemName + '  ';
                receipt += '\x1b\x61\x02'; // Right justification
                receipt += this.dataSet[i].price;
                receipt += '\n';
            }
            receipt += '--------------------------------\n';
            receipt += '\x1b\x61\x00'; // Left justification
            receipt += 'Pelanggan';
            receipt += '\x1b\x61\x02'; // Right justification
            receipt += this.nama_pelanggan + '\n';
            receipt += '\x1b\x61\x00'; // Left justification
            receipt += 'Total Item';
            receipt += '\x1b\x61\x02'; // Right justification
            receipt += this.total_item + '\n';
            receipt += '\x1b\x61\x00'; // Left justification
            receipt += 'Diskon';
            receipt += '\x1b\x61\x02'; // Right justification
            receipt += this.jumlah_diskon + '\n';
            receipt += 'PPN';
            receipt += '\x1b\x61\x02'; // Right justification
            receipt += this.pajak + '\n';
            receipt += 'Sub Total';   
            receipt += '\x1b\x61\x02'; // Right justification
            receipt += this.total +'\n';
            receipt += 'T O T A L';   
            receipt += '\x1b\x61\x02'; // Right justification
            receipt += this.total+'\n';
            receipt += '\x1b\x61\x01';
            receipt += '--------------------------------\n';
            receipt += 'Terimakasih Atas Kunjungan Anda\n';
            receipt += '--------------------------------\n';
            
            this.printProvider.testPrint(id, receipt);
        }
    }

    simpan_cetak() {
        if (this.userCart.payment_atachment < 0) {
            this.presentToast("Jumlah pembayaran yang anda masukan tidak mencukupi.");
        } else {
            //this.insertPenjualan();
            this.testPrint();
        }
    